﻿################### Инициализация ####################    
init python:
    xscr = initialize_adjustment('xscr')
    yscr = initialize_adjustment('yscr')

    vp_size_x,vp_size_y = config.screen_width/2,config.screen_height
    xpos,ypos = 0,0
    coords = 0,0
    selected = None
    show_overlay = true
    
    current_page = 0
    pages = ['pages/%s'%x for x in listdir('pages') if x.endswith('jpg') or x.endswith('png') or x.endswith('jpeg')]
    page = pages[current_page]
    page_size_x,page_size_y = renpy.image_size(page) 
    
    # raise Exception,
    
    if not exist('%s.txt'%page[:-4]):
        file = open(('%s.txt'%os.path.join(config.gamedir,page[:-4])),'w')
        file.close()

    data = []
    file = open(renpy.loader.transfn('%s.txt'%page[:-4]))
    txt = file.readlines()
    file.close()
    for line in txt:
        data.append(Structure())
        line = line.split('#')
        data[-1].set('x',int(line[0].split('x')[0]))
        data[-1].set('y',int(line[0].split('x')[1]))
        data[-1].set('height',int(line[1].split('x')[0]))
        data[-1].set('width',int(line[1].split('x')[1]))
        data[-1].set('font',line[2])
        data[-1].set('size',int(line[3]))
        data[-1].set('text',line[4].replace('\n','').replace('\r',''))
    
label start:
    scene bg
    show screen debugTools
    show screen Keyboard_Listener
    show screen page
    show screen controls
    show screen lst
    show screen trans
    
    python:
        store.yscr.change(0)
        store.xscr.change(0)
        # цикл обработки команд поступающих от интерфейсных блоков
        renpy.restart_interaction()
        while True:
            result = ui.interact()
            notify(toSafeString(result))
            if result[0] == 'edit':
                if result[1] == 'text':
                    show_overlay = false
                    input = renpy.input('%s: '%result[1],data[result[2]].get(result[1]))
                    data[result[2]].set(result[1],toSafeString(input))
                    show_overlay = true
                elif result[1] == 'remove':
                    data.pop(result[2])
                # else:
                elif result[1] == 'select':
                    selected = result[2]
                # else:
                    # input = renpy.input('%s: '%result[2],data[result[1]].get(result[2]),allow='0123456789')
                    # data[result[1]].set(result[2],int(input))
                # renpy.restart_interaction()
            
            elif result[0] == 'control':
                if result[1] == 'reset':
                    selected = None
                    
                if result[1] == 'toogle_overlay':
                    show_overlay = not show_overlay
                    
                elif result[1] == 'next_page' or result[1] == 'prev_page':
                    if result[1] == 'next_page' and current_page == len(pages)-1:
                        continue
                    elif result[1] == 'next_page' and current_page != len(pages)-1:
                        current_page += 1
                        
                    if result[1] == 'prev_page' and current_page == 0:
                        continue
                    elif result[1] == 'prev_page' and current_page != 0:
                        current_page -= 1
                        
                    store.yscr.change(0)
                    store.xscr.change(9999)
                        
                    page = pages[current_page]
                    page_size_x,page_size_y = renpy.image_size(page)
                    
                    if not exist('%s.txt'%page[:-4]):
                        file = open(('%s.txt'%os.path.join(config.gamedir,page[:-4])),'w')
                        file.close()
                    
                    data = []
                    file = open(renpy.loader.transfn('%s.txt'%page[:-4]))
                    txt = file.readlines()
                    file.close()
                    
                    for line in txt:
                        data.append(Structure())
                        line = line.split('#')
                        data[-1].set('x',int(line[0].split('x')[0]))
                        data[-1].set('y',int(line[0].split('x')[1]))
                        data[-1].set('height',int(line[1].split('x')[0]))
                        data[-1].set('width',int(line[1].split('x')[1]))
                        data[-1].set('font',line[2])
                        data[-1].set('size',int(line[3]))
                        data[-1].set('text',line[4].replace('\n','').replace('\r',''))
            
            file = open(renpy.loader.transfn('%s.txt'%page[:-4]),'w')
            for line in data:
                file.write('%dx%d#%dx%d#%s#%d#%s\n'%(line.x,line.y,line.height,line.width,line.font,line.size,line.text))
            file.close()
            
