﻿################### Блоки-функции ####################
# кнопки одновременно с фоном и текстом
screen Button:
    default x = 504
    default y = 136
    default img = 'menu.png'
    $normal = im.Crop(img,0,0,x,y/2)
    $hovered = im.Crop(img,0,y/2,x,y/2)
    fixed:
        maximum (x,y/2)
        imagebutton:
            idle normal
            xfill true
            yfill true
            hover hovered
            hovered gallery.tooltip.action(u'%s'%desc)
            action Return(value)
        text (u'%s'%txt) align(0.5,0.5)   

screen controlButton:
    default x = 159
    default y = 51
    fixed:
        maximum (x,y)
        imagebutton:
            idle 'idle.png'
            hover 'hover.png'
            action Return(value)
        text (u'%s'%txt) align(0.5,0.5)          

# imagebutton требующий только одну картинку
# вариант при наведении мыши получается из обычного подсвечиванием        
screen lightbutton:
    imagebutton yalign 0.5:
        idle (img)
        hover (im.MatrixColor(img,im.matrix.brightness(0.15)))
        action Return(return_value)
        
################### Основные интерфейсные блоки ####################
    
screen page:  
    viewport id 'fp':
        align (1.0,0.0)
        maximum (vp_size_x,vp_size_y)
        xadjustment xscr
        yadjustment yscr
        draggable True
        mousewheel True
        add(pages[current_page])
        
screen trans: 
    if show_overlay:
        for index,line in enumerate(data):
            $xplace,yplace = vp_coords(line.x,line.y)
            if xplace > (config.screen_width - vp_size_x) + line.width/2:
                if index == selected:
                    frame:
                        pos (xplace,yplace)
                        anchor (0.5,0.5)
                        maximum (line.width,line.height)
                        xfill true
                        yfill true  
                        background Frame('0256_cg00053.QNT.png',2,2)
                        text ("{font=%s}{color=#000}{size=%d}%s{/size}{/color}{/font}"%(line.font,line.size,line.text)) align (0.5,0.5)
                else:
                    frame:
                        pos (xplace,yplace)
                        anchor (0.5,0.5)
                        maximum (line.width,line.height)
                        xfill true
                        yfill true
                        text ("{font=%s}{color=#000}{size=%d}%s{/size}{/color}{/font}"%(line.font,line.size,line.text)) align (0.5,0.5)            
            else:
                null

            
            
screen controls:
    add(DynamicDisplayable(imagePositionFunction)) align (0.01,0.95)
    hbox:
        align (0.11,0.99)
        if show_overlay:
            textbutton ('откл перевод') action Return(['control','toogle_overlay'])
        else:
            textbutton ('вкл перевод') action Return(['control','toogle_overlay'])
        null width 20
        textbutton ('сброс фокус') action Return(['control','reset'])
        null width 20
        textbutton (' < ') action Return(['control','prev_page'])
        null width 5
        text ('%d - %d'%(current_page+1,len(pages)))
        null width 5
        textbutton (' > ') action Return(['control','next_page'])
        

screen lst:
    side 'c l':
        viewport id 'lst':
            maximum (config.screen_width/2,config.screen_height - 100)
            child_size (config.screen_width/2,90 * len(data) + 10)
            draggable True
            mousewheel True
            vbox:
                for index,line in enumerate(data):
                    hbox:
                        spacing 15
                        xalign 0.5
                        textbutton ('X') action Return(['edit','remove',index]) xmaximum 75 xfill true 
                        text ('x=%d'%line.x) #action Return(['edit',index,'x'])
                        text ('y=%d'%line.y) #action Return(['edit',index,'y'])
                        text ('h=%d'%line.height) #action Return(['edit',index,'height'])
                        text ('w=%d'%line.width) #action Return(['edit',index,'width'])
                        # text ('%s'%line.font[6:-4]) action Return(['edit',index,'font'])
                        text ('size=%d'%line.size) #action Return(['edit',index,'size'])
                        textbutton ('*') action Return(['edit','select',index]) xmaximum 75 xfill true 
                    textbutton ('%s'%line.text) action Return(['edit','text',index]) xfill true
                    null height 20
            vbar value XScrollValue('lst')

